/* -----------------------------------------------------------------------
 CommandStack.java
 Copyright (C) 2003  Nue

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
----------------------------------------------------------------------- */
/*
 * Created on 2003/11/01
 *
 * File Name: CommandStack.java
 * Encoding : EUC-JP
 * LineDelimiter: LF
 *
 */
package jp.co.jlight.undo;

import org.eclipse.swt.*;
import org.eclipse.swt.graphics.*;
import java.util.*;
/**
 * ޥɤ򤿤UndoRedo¹Ԥ
 */
public class CommandStack {
	
	private ArrayList history = new ArrayList();
	private int current = -1;
	private int index = -1;
	private boolean oneSegment = false;
	
	private TextUnit lastTextUnit = new TextUnit();
	
	public void append(CommandUnit cmdUnit) {
		TextUnit textUnit = cmdUnit.getTextUnit();
		CommandMacro cmdMacro;
		if (!oneSegment && checkNewSegment(textUnit)) {
			cmdMacro = new CommandMacro();
			append(cmdMacro);
		}
		try {
			if (textUnit.getDelString().length() > 0 || textUnit.getAddString().length() > 0) {
				getLastCommandMacro().append(cmdUnit);
			}
		} catch (NonLastCommandException e) {
		}
	}
	
	private void append(CommandMacro macro) {
		ArrayList al = null;
		CommandMacro cmdMacro = null;

		// listΥȰ֤ǸǤʤä(undo,redoǥȤѤä)ν
		if (current != index) {
			// åΰ־夫current֤ޤ
			// CommandMacroReverseɲ
			al = new ArrayList();
			for (int i = index; i > current; i--) {
				cmdMacro = (CommandMacro)history.get(i);
				al.add(cmdMacro.getCommandMacroReverse());
			}
			history.addAll(al);
			index = index + (index - current);
		}

		history.add(++index, macro);
		current = index;
	}

	/**
	 * Ϥ줿ʸ򸫤ƿʸΤޤ뤫ɤå
	 *  LineDelimiterCR+LF2ʸξ⤢뤳Ȥθ
	 * @param textUnit
	 * @return
	 */
	private boolean checkNewSegment(TextUnit textUnit) {
		boolean seg = true;

		int curAddLen = textUnit.getAddString().length();
		int curDelLen = textUnit.getDelString().length();
		int oldAddLen = lastTextUnit.getAddString().length();
		String curStr = textUnit.getAddString();
		String oldStr = lastTextUnit.getAddString();
		Point curAddPoint = textUnit.getAddPoint();
		Point oldAddPoint = lastTextUnit.getAddPoint();

		if (curDelLen == 0 && curAddLen == 0) {
			return false;
		}

		if ((curAddLen == 2 && isCRLF(curStr)) && (oldAddLen == 2 && isCRLF(oldStr))) {
			// ư2³ơCR+LFפϤ줿
			if (curAddPoint.x == (oldAddPoint.x + 2)) {
				seg = false;
			}
		} else if (curAddLen == 1 && oldAddLen == 1) {
			// ư2³ƱʸϤ줿ɤ
			if (curAddPoint.x == (oldAddPoint.x + 1)) {
				char chNow = curStr.charAt(0);
				char chOld = oldStr.charAt(0);

				if (chNow == '\t' && chOld == '\t') {
					seg = false;
				} else if (chNow == '\n' && chOld == '\n') {
					seg = false;
				} else if (chNow == ' ' && chOld == ' ') {
					seg = false;
				} else if ((chOld != '\t' && chOld != '\n' && chOld != ' ')
						&& (chNow == '\t' || chNow == '\n' || chNow == ' ')) {
					seg = true;
				} else if (chOld != '\t' && chOld != '\n' && chOld != ' ') {
					seg = false;
				} else {
				}
			}
		}

		// ǧѤѿ
		if (lastTextUnit == null) {
			lastTextUnit = new TextUnit(textUnit.getDelPoint(), textUnit.getDelString(),
										textUnit.getAddPoint(), textUnit.getAddString());
		} else {
			lastTextUnit.setDelPoint(textUnit.getDelPoint());
			lastTextUnit.setAddPoint(textUnit.getAddPoint());
			lastTextUnit.setDelString(textUnit.getDelString());
			lastTextUnit.setAddString(textUnit.getAddString());
		}

		return seg;
	}

	/**
	 * Ϥ줿ʸ󤬡CR+LFפɤʬ
	 * @param st
	 * @return boolean
	 */
	private boolean isCRLF(String st) {
		if (st == null) return false;
		if (st.length() == 2) {
			if (st.charAt(0) == SWT.CR && st.charAt(1) == SWT.LF) return true;
			if (st.charAt(0) == SWT.LF && st.charAt(1) == SWT.CR) return true;
		}
		return false;
	}

	/**
	 * ִѤα޽
	 *   Ϣ³ϤǤʤƤĤΥޥ()Ȥ
	 */
	public void setOneSegment(boolean segment) {
		this.oneSegment = segment;
		if (segment) {
			CommandMacro cmdMacro = new CommandMacro();
			append(cmdMacro);
		}
	}
	
	public void claer() {
		history.clear();
		current = -1;
		index = -1;
	}
	
	public int getSize() {
		return history.size();
	}
	
	public void undo() {
		if (current < 0) return;
		((CommandMacro)history.get(current--)).undo();
	}
	
	public void redo() {
		if (current > (getSize() - 2)) return;
		((CommandMacro)history.get(++current)).redo();
	}
	
	public boolean undoable() {
		if (current < 0) {
			return false;
		} else {
			return true; 
		}
	}
	
	public boolean redoable() {
		if (current > (getSize() - 2) || (current < 0 && getSize() < 1)) {
			return false;
		} else {
			return true;
		}
	}
	
	private CommandMacro getLastCommandMacro() throws NonLastCommandException{
		if (index < 0) throw new NonLastCommandException();
		return (CommandMacro)history.get(index);
	}
	
	class NonLastCommandException extends Exception {
	}
}
